//----------------------------------------------------------------------------
//  EDGE Misc Functions
//----------------------------------------------------------------------------
// 
//  Copyright (c) 2000  The EDGE Team.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//----------------------------------------------------------------------------

#include "../i_defs.h"
#include "../l_epi.h"

static char upper[256];

int L_StrNCaseCmpWild(const char *s1, const char *s2, int n)
{
  int i = 0;

  for (i = 0; s1[i] && s2[i] && i < n; i++)
  {
    if ((upper[s1[i]] != upper[s2[i]]) && (s1[i] != '?') && (s2[i] != '?'))
      break;
  }
  
  // If strings are equal, return equal.
  if (i == n)
    return 0;

  if (s1[i] == '?' || s2[i] == '?')
    return 0;

  return s1[i] - s2[i];
}

static void ShutdownMisc(void *data)
{
}

void L_StartupMisc(void)
{
  int i;

  for (i = 0; i < 256; i++)
    upper[i] = i;
  for (i = 'a'; i <= 'z'; i++)
    upper[i] = i + 'A' - 'a';

  L_RegisterShutdownRoutine(ShutdownMisc, NULL);
}
